//+------------------------------------------------------------------+
//|                                          TradeCopierProvider.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#property strict

input int CopierID;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   ObjectCreate("info", OBJ_LABEL, 0, 0, 0);
   ObjectSet("info",OBJPROP_COLOR,clrYellow);
   ObjectSetString(ChartID(), "info",OBJPROP_TEXT, "Signal Provider is running...");
   ObjectSet("info", OBJPROP_CORNER, 1);
   ObjectSet("info", OBJPROP_XDISTANCE, 10);
   ObjectSet("info", OBJPROP_YDISTANCE, 20);
   EventSetMillisecondTimer(100);
   
   fileName=StringConcatenate(CopierID,"_tradecopier.csv");
   
   WritePositionsIntoFile();
   
   
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
    ObjectDelete("info");
    FileDelete(fileName);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+

  
  double cachedPositionsInfo[];
  
  double currentPositionsInfo[];
  
  string fileName;

void OnTimer()
{   
   if(UpdateIsRequired())
      WritePositionsIntoFile();
}
  
void WritePositionsIntoFile(){
   int fileHandle=FileOpen(fileName,FILE_WRITE|FILE_TXT,',');

   for(int i=0; i<OrdersTotal(); i++){
      OrderSelect(i, SELECT_BY_POS,MODE_TRADES);
      if(OrderType()==OP_BUY  || OrderType()==OP_SELL){
      
         double volume = MarketInfo(OrderSymbol(),MODE_LOTSIZE)*OrderLots();
         
         FileWrite(fileHandle, OrderTicket(),OrderSymbol(), volume,OrderType(),OrderStopLoss(),OrderTakeProfit());
      }
   }
   
   FileClose(fileHandle);
}
  
bool UpdateIsRequired(){
 
   UpdatecurrentPositionsInfo();
   
   if(ArrayCompare(currentPositionsInfo,cachedPositionsInfo)==0)
   {        
      return false;
   }
   
   ArrayFree(cachedPositionsInfo);      
   ArrayResize(cachedPositionsInfo,ArraySize(currentPositionsInfo));
   ArrayCopy(cachedPositionsInfo,currentPositionsInfo,0,0);
   return true;
}
  
  void UpdatecurrentPositionsInfo(){
      int index=0;
      
      int ordersCount=OrdersTotal();
      
      ArrayFree(currentPositionsInfo);      
      ArrayResize(currentPositionsInfo,ordersCount*5);
      ArrayInitialize(currentPositionsInfo,0);
            
      
      for(int i=0; i<ordersCount; i++){
         OrderSelect(i, SELECT_BY_POS,MODE_TRADES);
         
         if(OrderType()==OP_BUY  || OrderType()==OP_SELL){
            double volume = MarketInfo(OrderSymbol(),MODE_LOTSIZE)*OrderLots();
            currentPositionsInfo[index++]=OrderTicket();
            currentPositionsInfo[index++]=volume;
            currentPositionsInfo[index++]=OrderType();
            currentPositionsInfo[index++]=OrderStopLoss();
            currentPositionsInfo[index++]=OrderTakeProfit();
         }
      }
  }
//+------------------------------------------------------------------+
